package com.zine.zinemob.scene.controller;

/**
 * Interface para um controlador que deve ser atualizado a cada iterao do lao
 * da cena. Se uma instncia de SceneElementController implementar esta interface
 * e for adicionada a uma cena, ento o seu mtodo update  chamado a cada iterao
 * do lao, antes da rotina de desenho.
 */
public interface Updateble {

	/**
	 * Mtodo que deve ser implementado para a rotina de atualizao do controle.
	 */
	public void update();

}
